Unit ADP8C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFP8C_p;

procedure ADP8C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer);

implementation

procedure ADP8C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer);
var
I :Integer;
label
_1,_2,_3,_4,_5;
begin
AFP8C(A,N,N);
D1 := Cmplx(1.0,0.0);
D2 := 0;
for I:=1 to N do
 begin
  D1 := MulC(D1,A[(I-1)+(I-1)*N]);
  if ( Cabs(D1) = 0.0 ) 
   then goto _4;
_1:
  if ( Cabs(D1) < 1 ) 
   then goto _2;
  D1 := MulC(D1,Cmplx(0.0625,0.0));
  D2 := D2+4;
  goto _1;
_2:
  if ( Cabs(D1) >= 0.0625 ) 
   then goto _3;
  D1 := MulC(D1,Cmplx(16.0,0.0));
  D2 := D2-4;
  goto _2;
_3:
 end;
goto _5;
_4:
D1 := Cmplx(0.0,0.0);
D2 := 0;
_5:
end;

end.
