Unit AFP8C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP8C(var A :Array of Complex; N :Integer; M :Integer);

implementation

procedure AFP8C(var A :Array of Complex; N :Integer; M :Integer);
var
I,J,K,L :Integer;
R,A1,A2,E :Real;
S1,R1,R2,P,T,C,S :Complex;
label
_1,_2,_3,_4,_5,_6;
begin
for K:=1 to M do
 begin
  L := K+1;
  if ( L > N ) 
   then goto _6;
  for I:=L to N do
   begin
    R2 := A[(I-1)+(K-1)*N];
    A2 := Cabs(R2);
    if ( A2 = 0.0 ) 
     then goto _5;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Cabs(R1);
    if ( A1 <> 0.0 ) 
     then goto _1;
    T := Cmplx(1.0,0.0);
    A[(K-1)+(K-1)*N] :=SubC(Cmplx(0.0,0.0),A[(I-1)+(K-1)*N]);
    goto _3;
_1:
    if ( A1 <= A2 ) 
     then goto _2;
    P := DivC(SubC(Cmplx(0.0,0.0),R2),R1);
    E := A2/A1;
    R := Sqrt(1.0+E*E);
    T := DivC(P,Cmplx(R+1.0,0.0));
    A[(K-1)+(K-1)*N] := MulC(Conjg(DivC(Cmplx(A1,0.0),R1)),Cmplx(A1*R,0.0));
    goto _3;
_2:
    P := DivC(SubC(Cmplx(0.0,0.0),R1),R2);
    E := A1/A2;
    R := Sqrt(1.0+E*E);
    C := DivC(Cmplx(A1,0.0),R1);
    S := DivC(Cmplx(A2,0.0),R2);
    T := DivC(SubC(Cmplx(0.0,0.0),C),MulC(S,Cmplx(R+E,0.0)));
    A[(K-1)+(K-1)*N] := MulC(Conjg(C),Cmplx(A2*R,0.0));
_3:
    A[(I-1)+(K-1)*N] := T;
    E := Cabs(T);
    R := E*E;
    A1 := 1.0/(1.0+R);
    C := Cmplx((1.0-R)*A1,0.0);
    S := MulC((AddC(T,T)),Cmplx(A1,0.0));
    S1 := Conjg(S);
    if ( L > M )
     then goto _5;
    for J:=L to M do
     begin
      R1 := A[(K-1)+(J-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(K-1)+(J-1)*N] := SubC(MulC(C,R1),MulC(S1,R2));
      A[(I-1)+(J-1)*N] := AddC(MulC(S,R1),MulC(C,R2));
_4:
     end;
_5:
   end;
_6:
 end;
end;

end.
